

from FlagEmbedding import BGEM3FlagModel
from llmengine.base_embedding import BaseEmbedding, llm_register

class BgeEmbedding(BaseEmbedding):
	def __init__(self, model_id):
		self.model_id = model_id
		self.model_name = model_id.split('/')[-1]
		self.model = BGEM3FlagModel(model_id, use_fp16=True) 
		# Setting use_fp16 to True speeds up computation with a slight performance degradation
		self.kwargs = {
			"batch_size": 12,
			"max_length": 8192
		}

	def encode(self, input):
		ret = []
		for t in input:	
			embedding = model.encode(sentences_1, **self.kwargs)['dense_vecs']
			ret.append(embedding
		return ret

llm_register('bge-m3', BgeEmbedding)
